/* ***********************************************************
 * This file was automatically generated on 2012-12-21.      *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generator git on tinkerforge.com                   *
 *************************************************************/

using System;

namespace Tinkerforge
{
	/// <summary>
	///  Device for controlling up to 4 Solid State Relays
	/// </summary>
	public class BrickletIndustrialQuadRelay : Device 
	{

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletIndustrialQuadRelay.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletIndustrialQuadRelay.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletIndustrialQuadRelay.SetResponseExpectedAll"/>.
		/// </summary>
		public static byte FUNCTION_SET_VALUE = 1;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletIndustrialQuadRelay.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletIndustrialQuadRelay.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletIndustrialQuadRelay.SetResponseExpectedAll"/>.
		/// </summary>
		public static byte FUNCTION_GET_VALUE = 2;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletIndustrialQuadRelay.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletIndustrialQuadRelay.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletIndustrialQuadRelay.SetResponseExpectedAll"/>.
		/// </summary>
		public static byte FUNCTION_SET_MONOFLOP = 3;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletIndustrialQuadRelay.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletIndustrialQuadRelay.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletIndustrialQuadRelay.SetResponseExpectedAll"/>.
		/// </summary>
		public static byte FUNCTION_GET_MONOFLOP = 4;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletIndustrialQuadRelay.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletIndustrialQuadRelay.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletIndustrialQuadRelay.SetResponseExpectedAll"/>.
		/// </summary>
		public static byte FUNCTION_SET_GROUP = 5;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletIndustrialQuadRelay.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletIndustrialQuadRelay.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletIndustrialQuadRelay.SetResponseExpectedAll"/>.
		/// </summary>
		public static byte FUNCTION_GET_GROUP = 6;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletIndustrialQuadRelay.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletIndustrialQuadRelay.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletIndustrialQuadRelay.SetResponseExpectedAll"/>.
		/// </summary>
		public static byte FUNCTION_GET_AVAILABLE_FOR_GROUP = 7;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletIndustrialQuadRelay.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletIndustrialQuadRelay.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletIndustrialQuadRelay.SetResponseExpectedAll"/>.
		/// </summary>
		public static byte CALLBACK_MONOFLOP_DONE = 8;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletIndustrialQuadRelay.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletIndustrialQuadRelay.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletIndustrialQuadRelay.SetResponseExpectedAll"/>.
		/// </summary>
		public static byte FUNCTION_GET_IDENTITY = 255;


		/// <summary>
		///  This callback is triggered whenever a monoflop timer reaches 0. The
		///  parameters contain the involved pins and the current value of the pins
		///  (the value after the monoflop).
		/// </summary>
		public event MonoflopDoneEventHandler MonoflopDone;
		public delegate void MonoflopDoneEventHandler(object sender, int pinMask, int valueMask);

		/// <summary>
		///  Creates an object with the unique device ID <c>uid</c>. This object can
		///  then be added to the IP connection.
		/// </summary>
		public BrickletIndustrialQuadRelay(string uid, IPConnection ipcon) : base(uid, ipcon) 
		{
			this.bindingVersion[0] = 1;
			this.bindingVersion[1] = 0;
			this.bindingVersion[2] = 0;
			messageCallbacks[CALLBACK_MONOFLOP_DONE] = new MessageCallback(OnMonoflopDone);

			responseExpected[FUNCTION_SET_VALUE] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_VALUE] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_MONOFLOP] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_MONOFLOP] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_GROUP] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_GROUP] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_AVAILABLE_FOR_GROUP] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_IDENTITY] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[CALLBACK_MONOFLOP_DONE] = ResponseExpectedFlag.ALWAYS_FALSE;
		}

		/// <summary>
		///  Sets the output value with a bitmask. The bitmask
		///  is 16 bit long, *true* refers to a closed relay and *false* refers to 
		///  an open relay.
		///  
		///  For example: The value 0b0000000000000011 will close the relay 
		///  of pins 0-1 and open the other pins.
		///  
		///  If no groups are used (see <see cref="Tinkerforge.BrickletIndustrialQuadRelay.SetGroup"/>), the pins correspond to the
		///  markings on the Quad Relay Bricklet.
		///  
		///  If groups are used, the pins correspond to the element in the group.
		///  Element 1 in the group will get pins 0-3, element 2 pins 4-7, element 3
		///  pins 8-11 and element 4 pins 12-15.
		/// </summary>
		public void SetValue(int valueMask)
		{
			byte[] data_ = MakePacketHeader(10, FUNCTION_SET_VALUE);
			LEConverter.To((short)valueMask, 8, data_);

			if(responseExpected[FUNCTION_SET_VALUE] == ResponseExpectedFlag.ALWAYS_TRUE || responseExpected[FUNCTION_SET_VALUE] == ResponseExpectedFlag.TRUE) 
			{
				byte[] response;
				SendRequestExpectResponse(data_, FUNCTION_SET_VALUE, out response);
			}
			else
			{
				SendRequestNoResponse(data_);
			}
		}

		/// <summary>
		///  Returns the bitmask as set by <see cref="Tinkerforge.BrickletIndustrialQuadRelay.SetValue"/>.
		/// </summary>
		public int GetValue()
		{
			byte[] data_ = MakePacketHeader(8, FUNCTION_GET_VALUE);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_VALUE, out response);

			return LEConverter.UShortFrom(8, response);
		}

		/// <summary>
		///  Configures a monoflop of the pins specified by the first parameter
		///  bitmask.
		///  
		///  The second parameter is a bitmask with the desired value of the specified
		///  pins (*true* means relay closed and *false* means relay open).
		///  
		///  The third parameter indicates the time (in ms) that the pins should hold
		///  the value.
		///  
		///  If this function is called with the parameters 
		///  ((1 &lt;&lt; 0) | (1 &lt;&lt; 3), (1 &lt;&lt; 0), 1500):
		///  Pin 0 will close and pin 3 will open. In 1.5s pin 0 will open and pin
		///  3 will close again.
		///  
		///  A monoflop can be used as a fail-safe mechanism. For example: Lets assume you
		///  have a RS485 bus and a Quad Relay Bricklet connected to one of the slave
		///  stacks. You can now call this function every second, with a time parameter
		///  of two seconds and pin 0 closed. Pin 0 will be closed all the time. If now
		///  the RS485 connection is lost, then pin 0 will be opened in at most two seconds.
		/// </summary>
		public void SetMonoflop(int pinMask, int valueMask, long time)
		{
			byte[] data_ = MakePacketHeader(16, FUNCTION_SET_MONOFLOP);
			LEConverter.To((short)pinMask, 8, data_);
			LEConverter.To((short)valueMask, 10, data_);
			LEConverter.To((int)time, 12, data_);

			if(responseExpected[FUNCTION_SET_MONOFLOP] == ResponseExpectedFlag.ALWAYS_TRUE || responseExpected[FUNCTION_SET_MONOFLOP] == ResponseExpectedFlag.TRUE) 
			{
				byte[] response;
				SendRequestExpectResponse(data_, FUNCTION_SET_MONOFLOP, out response);
			}
			else
			{
				SendRequestNoResponse(data_);
			}
		}

		/// <summary>
		///  Returns (for the given pin) the current value and the time as set by
		///  <see cref="Tinkerforge.BrickletIndustrialQuadRelay.SetMonoflop"/> as well as the remaining time until the value flips.
		///  
		///  If the timer is not running currently, the remaining time will be returned
		///  as 0.
		/// </summary>
		public void GetMonoflop(byte pin, out int value, out long time, out long timeRemaining)
		{
			byte[] data_ = MakePacketHeader(9, FUNCTION_GET_MONOFLOP);
			LEConverter.To((byte)pin, 8, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_MONOFLOP, out response);

			value = LEConverter.UShortFrom(8, response);
			time = LEConverter.UIntFrom(10, response);
			timeRemaining = LEConverter.UIntFrom(14, response);
		}

		/// <summary>
		///  Sets a group of Quad Relay Bricklets that should work together. You can
		///  find Bricklets that can be grouped together with <see cref="Tinkerforge.BrickletIndustrialQuadRelay.GetAvailableForGroup"/>.
		///  
		///  The group consists of 4 elements. Element 1 in the group will get pins 0-3,
		///  element 2 pins 4-7, element 3 pins 8-11 and element 4 pins 12-15.
		///  
		///  Each element can either be one of the ports ('a' to 'd') or 'n' if it should
		///  not be used.
		///  
		///  For example: If you have two Quad Relay Bricklets connected to port A and
		///  port B respectively, you could call with "['a', 'b', 'n', 'n']".
		///  
		///  Now the pins on the Quad Relay on port A are assigned to 0-3 and the
		///  pins on the Quad Relay on port B are assigned to 4-7. It is now possible
		///  to call <see cref="Tinkerforge.BrickletIndustrialQuadRelay.SetValue"/> and control two Bricklets at the same time.
		/// </summary>
		public void SetGroup(char[] group)
		{
			byte[] data_ = MakePacketHeader(12, FUNCTION_SET_GROUP);
			LEConverter.To((char[])group, 8, 4, data_);

			if(responseExpected[FUNCTION_SET_GROUP] == ResponseExpectedFlag.ALWAYS_TRUE || responseExpected[FUNCTION_SET_GROUP] == ResponseExpectedFlag.TRUE) 
			{
				byte[] response;
				SendRequestExpectResponse(data_, FUNCTION_SET_GROUP, out response);
			}
			else
			{
				SendRequestNoResponse(data_);
			}
		}

		/// <summary>
		///  Returns the group as set by <see cref="Tinkerforge.BrickletIndustrialQuadRelay.SetGroup"/>
		/// </summary>
		public char[] GetGroup()
		{
			byte[] data_ = MakePacketHeader(8, FUNCTION_GET_GROUP);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_GROUP, out response);

			return LEConverter.CharArrayFrom(8, response, 4);
		}

		/// <summary>
		///  Returns a bitmask of ports that are available for grouping. For example the
		///  value 0b0101 means: Port *A* and Port *C* are connected to Bricklets that
		///  can be grouped together.
		/// </summary>
		public byte GetAvailableForGroup()
		{
			byte[] data_ = MakePacketHeader(8, FUNCTION_GET_AVAILABLE_FOR_GROUP);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_AVAILABLE_FOR_GROUP, out response);

			return LEConverter.ByteFrom(8, response);
		}

		/// <summary>
		///  Returns the UID, the UID where the Bricklet is connected to, 
		///  the position, the hardware and firmware version as well as the
		///  device identifier.
		///  
		///  The position can be 'a', 'b', 'c' or 'd'.
		///  
		///  The device identifiers are:
		///  
		///  <code>
		///   "Device Identifier", "Device"
		///  
		///   "11", "Brick DC"
		///   "12", "Brick Debug"
		///   "13", "Brick Master 2.0"
		///   "14", "Brick Servo"
		///   "15", "Brick Stepper"
		///   "16", "Brick IMU"
		///   "", ""
		///   "21", "Bricklet Ambient Light"
		///   "22", "Bricklet Breakout"
		///   "23", "Bricklet Current12"
		///   "24", "Bricklet Current25"
		///   "25", "Bricklet Distance IR"
		///   "26", "Bricklet Dual Relay"
		///   "27", "Bricklet Humidity"
		///   "28", "Bricklet IO-16"
		///   "29", "Bricklet IO-4"
		///   "210", "Bricklet Joystick"
		///   "211", "Bricklet LCD 16x2"
		///   "212", "Bricklet LCD 20x4"
		///   "213", "Bricklet Linear Poti"
		///   "214", "Bricklet Piezo Buzzer"
		///   "215", "Bricklet Rotary Poti"
		///   "216", "Bricklet Temperature"
		///   "217", "Bricklet Temperature IR"
		///   "218", "Bricklet Voltage"
		///   "219", "Bricklet Analog In"
		///   "220", "Bricklet Analog Out"
		///   "221", "Bricklet Barometer"
		///   "222", "Bricklet GPS"
		///   "223", "Bricklet Industrial Digital In 4"
		///   "224", "Bricklet Industrial Digital Out 4"
		///   "225", "Bricklet Industrial Quad Relay"
		///   "226", "Bricklet PTC"
		///   "227", "Bricklet Voltage/Current"
		///  </code>
		///  
		///  .. versionadded:: 2.0.0~(Plugin)
		/// </summary>
		public void GetIdentity(out string uid, out string connectedUid, out char position, out byte[] hardwareVersion, out byte[] firmwareVersion, out int deviceIdentifier)
		{
			byte[] data_ = MakePacketHeader(8, FUNCTION_GET_IDENTITY);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_IDENTITY, out response);

			uid = LEConverter.StringFrom(8, response, 8);
			connectedUid = LEConverter.StringFrom(16, response, 8);
			position = LEConverter.CharFrom(24, response);
			hardwareVersion = LEConverter.ByteArrayFrom(25, response, 3);
			firmwareVersion = LEConverter.ByteArrayFrom(28, response, 3);
			deviceIdentifier = LEConverter.UShortFrom(31, response);
		}

		/// <summary>
		/// </summary>
		protected void OnMonoflopDone(byte[] data_)
		{
			int pinMask = LEConverter.UShortFrom(8, data_);
			int valueMask = LEConverter.UShortFrom(10, data_);

			var handler = MonoflopDone;
			if(handler != null)
			{
				handler(this, pinMask, valueMask);
			}
		}
	}
}