/* ***********************************************************
 * This file was automatically generated on 2012-12-21.      *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generator git on tinkerforge.com                   *
 *************************************************************/

using System;

namespace Tinkerforge
{
	/// <summary>
	///  Device for controlling a LCD with 2 lines a 16 characters
	/// </summary>
	public class BrickletLCD16x2 : Device 
	{

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletLCD16x2.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletLCD16x2.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletLCD16x2.SetResponseExpectedAll"/>.
		/// </summary>
		public static byte FUNCTION_WRITE_LINE = 1;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletLCD16x2.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletLCD16x2.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletLCD16x2.SetResponseExpectedAll"/>.
		/// </summary>
		public static byte FUNCTION_CLEAR_DISPLAY = 2;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletLCD16x2.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletLCD16x2.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletLCD16x2.SetResponseExpectedAll"/>.
		/// </summary>
		public static byte FUNCTION_BACKLIGHT_ON = 3;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletLCD16x2.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletLCD16x2.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletLCD16x2.SetResponseExpectedAll"/>.
		/// </summary>
		public static byte FUNCTION_BACKLIGHT_OFF = 4;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletLCD16x2.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletLCD16x2.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletLCD16x2.SetResponseExpectedAll"/>.
		/// </summary>
		public static byte FUNCTION_IS_BACKLIGHT_ON = 5;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletLCD16x2.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletLCD16x2.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletLCD16x2.SetResponseExpectedAll"/>.
		/// </summary>
		public static byte FUNCTION_SET_CONFIG = 6;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletLCD16x2.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletLCD16x2.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletLCD16x2.SetResponseExpectedAll"/>.
		/// </summary>
		public static byte FUNCTION_GET_CONFIG = 7;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletLCD16x2.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletLCD16x2.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletLCD16x2.SetResponseExpectedAll"/>.
		/// </summary>
		public static byte FUNCTION_IS_BUTTON_PRESSED = 8;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletLCD16x2.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletLCD16x2.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletLCD16x2.SetResponseExpectedAll"/>.
		/// </summary>
		public static byte CALLBACK_BUTTON_PRESSED = 9;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletLCD16x2.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletLCD16x2.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletLCD16x2.SetResponseExpectedAll"/>.
		/// </summary>
		public static byte CALLBACK_BUTTON_RELEASED = 10;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletLCD16x2.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletLCD16x2.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletLCD16x2.SetResponseExpectedAll"/>.
		/// </summary>
		public static byte FUNCTION_GET_IDENTITY = 255;


		/// <summary>
		///  This callback is triggered when a button is pressed. The parameter is
		///  the number of the button (0 to 2).
		/// </summary>
		public event ButtonPressedEventHandler ButtonPressed;
		public delegate void ButtonPressedEventHandler(object sender, byte button);

		/// <summary>
		///  This callback is triggered when a button is released. The parameter is
		///  the number of the button (0 to 2).
		/// </summary>
		public event ButtonReleasedEventHandler ButtonReleased;
		public delegate void ButtonReleasedEventHandler(object sender, byte button);

		/// <summary>
		///  Creates an object with the unique device ID <c>uid</c>. This object can
		///  then be added to the IP connection.
		/// </summary>
		public BrickletLCD16x2(string uid, IPConnection ipcon) : base(uid, ipcon) 
		{
			this.bindingVersion[0] = 1;
			this.bindingVersion[1] = 0;
			this.bindingVersion[2] = 0;
			messageCallbacks[CALLBACK_BUTTON_PRESSED] = new MessageCallback(OnButtonPressed);
			messageCallbacks[CALLBACK_BUTTON_RELEASED] = new MessageCallback(OnButtonReleased);

			responseExpected[FUNCTION_WRITE_LINE] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_CLEAR_DISPLAY] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_BACKLIGHT_ON] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_BACKLIGHT_OFF] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_IS_BACKLIGHT_ON] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_CONFIG] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_CONFIG] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_IS_BUTTON_PRESSED] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_IDENTITY] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[CALLBACK_BUTTON_PRESSED] = ResponseExpectedFlag.ALWAYS_FALSE;
			responseExpected[CALLBACK_BUTTON_RELEASED] = ResponseExpectedFlag.ALWAYS_FALSE;
		}

		/// <summary>
		///  Writes text to a specific line (0 to 1) with a specific position 
		///  (0 to 15). The text can have a maximum of 16 characters.
		///  
		///  For example: (0, 5, "Hello") will write *Hello* in the middle of the
		///  first line of the display.
		///  
		///  The display uses a special charset that includes all ASCII characters except
		///  backslash and tilde. The LCD charset also includes several other non-ASCII characters, see
		///  the `charset specification &lt;https://github.com/Tinkerforge/lcd-16x2-bricklet/raw/master/datasheets/standard_charset.pdf&gt;`__
		///  for details. The Unicode example above shows how to specify non-ASCII characters
		///  and how to translate from Unicode to the LCD charset.
		/// </summary>
		public void WriteLine(byte line, byte position, string text)
		{
			byte[] data_ = MakePacketHeader(26, FUNCTION_WRITE_LINE);
			LEConverter.To((byte)line, 8, data_);
			LEConverter.To((byte)position, 9, data_);
			LEConverter.To((string)text, 10, 16, data_);

			if(responseExpected[FUNCTION_WRITE_LINE] == ResponseExpectedFlag.ALWAYS_TRUE || responseExpected[FUNCTION_WRITE_LINE] == ResponseExpectedFlag.TRUE) 
			{
				byte[] response;
				SendRequestExpectResponse(data_, FUNCTION_WRITE_LINE, out response);
			}
			else
			{
				SendRequestNoResponse(data_);
			}
		}

		/// <summary>
		///  Deletes all characters from the display.
		/// </summary>
		public void ClearDisplay()
		{
			byte[] data_ = MakePacketHeader(8, FUNCTION_CLEAR_DISPLAY);

			if(responseExpected[FUNCTION_CLEAR_DISPLAY] == ResponseExpectedFlag.ALWAYS_TRUE || responseExpected[FUNCTION_CLEAR_DISPLAY] == ResponseExpectedFlag.TRUE) 
			{
				byte[] response;
				SendRequestExpectResponse(data_, FUNCTION_CLEAR_DISPLAY, out response);
			}
			else
			{
				SendRequestNoResponse(data_);
			}
		}

		/// <summary>
		///  Turns the backlight on.
		/// </summary>
		public void BacklightOn()
		{
			byte[] data_ = MakePacketHeader(8, FUNCTION_BACKLIGHT_ON);

			if(responseExpected[FUNCTION_BACKLIGHT_ON] == ResponseExpectedFlag.ALWAYS_TRUE || responseExpected[FUNCTION_BACKLIGHT_ON] == ResponseExpectedFlag.TRUE) 
			{
				byte[] response;
				SendRequestExpectResponse(data_, FUNCTION_BACKLIGHT_ON, out response);
			}
			else
			{
				SendRequestNoResponse(data_);
			}
		}

		/// <summary>
		///  Turns the backlight off.
		/// </summary>
		public void BacklightOff()
		{
			byte[] data_ = MakePacketHeader(8, FUNCTION_BACKLIGHT_OFF);

			if(responseExpected[FUNCTION_BACKLIGHT_OFF] == ResponseExpectedFlag.ALWAYS_TRUE || responseExpected[FUNCTION_BACKLIGHT_OFF] == ResponseExpectedFlag.TRUE) 
			{
				byte[] response;
				SendRequestExpectResponse(data_, FUNCTION_BACKLIGHT_OFF, out response);
			}
			else
			{
				SendRequestNoResponse(data_);
			}
		}

		/// <summary>
		///  Returns *true* if the backlight is on and *false* otherwise.
		/// </summary>
		public bool IsBacklightOn()
		{
			byte[] data_ = MakePacketHeader(8, FUNCTION_IS_BACKLIGHT_ON);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_IS_BACKLIGHT_ON, out response);

			return LEConverter.BoolFrom(8, response);
		}

		/// <summary>
		///  Configures if the cursor (shown as "_") should be visible and if it
		///  should be blinking (shown as a blinking block). The cursor position
		///  is one character behind the the last text written with 
		///  <see cref="Tinkerforge.BrickletLCD16x2.WriteLine"/>.
		///  
		///  The default is (false, false).
		/// </summary>
		public void SetConfig(bool cursor, bool blinking)
		{
			byte[] data_ = MakePacketHeader(10, FUNCTION_SET_CONFIG);
			LEConverter.To((bool)cursor, 8, data_);
			LEConverter.To((bool)blinking, 9, data_);

			if(responseExpected[FUNCTION_SET_CONFIG] == ResponseExpectedFlag.ALWAYS_TRUE || responseExpected[FUNCTION_SET_CONFIG] == ResponseExpectedFlag.TRUE) 
			{
				byte[] response;
				SendRequestExpectResponse(data_, FUNCTION_SET_CONFIG, out response);
			}
			else
			{
				SendRequestNoResponse(data_);
			}
		}

		/// <summary>
		///  Returns the configuration as set by <see cref="Tinkerforge.BrickletLCD16x2.SetConfig"/>.
		/// </summary>
		public void GetConfig(out bool cursor, out bool blinking)
		{
			byte[] data_ = MakePacketHeader(8, FUNCTION_GET_CONFIG);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_CONFIG, out response);

			cursor = LEConverter.BoolFrom(8, response);
			blinking = LEConverter.BoolFrom(9, response);
		}

		/// <summary>
		///  Returns *true* if the button (0 to 2) is pressed. If you want to react
		///  on button presses and releases it is recommended to use the
		///  <see cref="Tinkerforge.BrickletLCD16x2.ButtonPressed"/> and <see cref="Tinkerforge.BrickletLCD16x2.ButtonReleased"/> callbacks.
		/// </summary>
		public bool IsButtonPressed(byte button)
		{
			byte[] data_ = MakePacketHeader(9, FUNCTION_IS_BUTTON_PRESSED);
			LEConverter.To((byte)button, 8, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_IS_BUTTON_PRESSED, out response);

			return LEConverter.BoolFrom(8, response);
		}

		/// <summary>
		///  Returns the UID, the UID where the Bricklet is connected to, 
		///  the position, the hardware and firmware version as well as the
		///  device identifier.
		///  
		///  The position can be 'a', 'b', 'c' or 'd'.
		///  
		///  The device identifiers are:
		///  
		///  <code>
		///   "Device Identifier", "Device"
		///  
		///   "11", "Brick DC"
		///   "12", "Brick Debug"
		///   "13", "Brick Master 2.0"
		///   "14", "Brick Servo"
		///   "15", "Brick Stepper"
		///   "16", "Brick IMU"
		///   "", ""
		///   "21", "Bricklet Ambient Light"
		///   "22", "Bricklet Breakout"
		///   "23", "Bricklet Current12"
		///   "24", "Bricklet Current25"
		///   "25", "Bricklet Distance IR"
		///   "26", "Bricklet Dual Relay"
		///   "27", "Bricklet Humidity"
		///   "28", "Bricklet IO-16"
		///   "29", "Bricklet IO-4"
		///   "210", "Bricklet Joystick"
		///   "211", "Bricklet LCD 16x2"
		///   "212", "Bricklet LCD 20x4"
		///   "213", "Bricklet Linear Poti"
		///   "214", "Bricklet Piezo Buzzer"
		///   "215", "Bricklet Rotary Poti"
		///   "216", "Bricklet Temperature"
		///   "217", "Bricklet Temperature IR"
		///   "218", "Bricklet Voltage"
		///   "219", "Bricklet Analog In"
		///   "220", "Bricklet Analog Out"
		///   "221", "Bricklet Barometer"
		///   "222", "Bricklet GPS"
		///   "223", "Bricklet Industrial Digital In 4"
		///   "224", "Bricklet Industrial Digital Out 4"
		///   "225", "Bricklet Industrial Quad Relay"
		///   "226", "Bricklet PTC"
		///   "227", "Bricklet Voltage/Current"
		///  </code>
		///  
		///  .. versionadded:: 2.0.0~(Plugin)
		/// </summary>
		public void GetIdentity(out string uid, out string connectedUid, out char position, out byte[] hardwareVersion, out byte[] firmwareVersion, out int deviceIdentifier)
		{
			byte[] data_ = MakePacketHeader(8, FUNCTION_GET_IDENTITY);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_IDENTITY, out response);

			uid = LEConverter.StringFrom(8, response, 8);
			connectedUid = LEConverter.StringFrom(16, response, 8);
			position = LEConverter.CharFrom(24, response);
			hardwareVersion = LEConverter.ByteArrayFrom(25, response, 3);
			firmwareVersion = LEConverter.ByteArrayFrom(28, response, 3);
			deviceIdentifier = LEConverter.UShortFrom(31, response);
		}

		/// <summary>
		/// </summary>
		protected void OnButtonPressed(byte[] data_)
		{
			byte button = LEConverter.ByteFrom(8, data_);

			var handler = ButtonPressed;
			if(handler != null)
			{
				handler(this, button);
			}
		}

		/// <summary>
		/// </summary>
		protected void OnButtonReleased(byte[] data_)
		{
			byte button = LEConverter.ByteFrom(8, data_);

			var handler = ButtonReleased;
			if(handler != null)
			{
				handler(this, button);
			}
		}
	}
}