/* ***********************************************************
 * This file was automatically generated on 2012-12-21.      *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generator git on tinkerforge.com                   *
 *************************************************************/

using System;

namespace Tinkerforge
{
	/// <summary>
	///  Device for controlling a piezo buzzer
	/// </summary>
	public class BrickletPiezoBuzzer : Device 
	{

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletPiezoBuzzer.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletPiezoBuzzer.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletPiezoBuzzer.SetResponseExpectedAll"/>.
		/// </summary>
		public static byte FUNCTION_BEEP = 1;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletPiezoBuzzer.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletPiezoBuzzer.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletPiezoBuzzer.SetResponseExpectedAll"/>.
		/// </summary>
		public static byte FUNCTION_MORSE_CODE = 2;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletPiezoBuzzer.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletPiezoBuzzer.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletPiezoBuzzer.SetResponseExpectedAll"/>.
		/// </summary>
		public static byte CALLBACK_BEEP_FINISHED = 3;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletPiezoBuzzer.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletPiezoBuzzer.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletPiezoBuzzer.SetResponseExpectedAll"/>.
		/// </summary>
		public static byte CALLBACK_MORSE_CODE_FINISHED = 4;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletPiezoBuzzer.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletPiezoBuzzer.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletPiezoBuzzer.SetResponseExpectedAll"/>.
		/// </summary>
		public static byte FUNCTION_GET_IDENTITY = 255;


		/// <summary>
		///  This callback is triggered if a beep set by <see cref="Tinkerforge.BrickletPiezoBuzzer.Beep"/> is finished
		/// </summary>
		public event BeepFinishedEventHandler BeepFinished;
		public delegate void BeepFinishedEventHandler(object sender);

		/// <summary>
		///  This callback is triggered if the playback of the morse code set by
		///  <see cref="Tinkerforge.BrickletPiezoBuzzer.MorseCode"/> is finished.
		/// </summary>
		public event MorseCodeFinishedEventHandler MorseCodeFinished;
		public delegate void MorseCodeFinishedEventHandler(object sender);

		/// <summary>
		///  Creates an object with the unique device ID <c>uid</c>. This object can
		///  then be added to the IP connection.
		/// </summary>
		public BrickletPiezoBuzzer(string uid, IPConnection ipcon) : base(uid, ipcon) 
		{
			this.bindingVersion[0] = 1;
			this.bindingVersion[1] = 0;
			this.bindingVersion[2] = 0;
			messageCallbacks[CALLBACK_BEEP_FINISHED] = new MessageCallback(OnBeepFinished);
			messageCallbacks[CALLBACK_MORSE_CODE_FINISHED] = new MessageCallback(OnMorseCodeFinished);

			responseExpected[FUNCTION_BEEP] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_MORSE_CODE] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_IDENTITY] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[CALLBACK_BEEP_FINISHED] = ResponseExpectedFlag.ALWAYS_FALSE;
			responseExpected[CALLBACK_MORSE_CODE_FINISHED] = ResponseExpectedFlag.ALWAYS_FALSE;
		}

		/// <summary>
		///  Beeps with the duration in ms. For example: If you set a value of 1000,
		///  the piezo buzzer will beep for one second.
		/// </summary>
		public void Beep(long duration)
		{
			byte[] data_ = MakePacketHeader(12, FUNCTION_BEEP);
			LEConverter.To((int)duration, 8, data_);

			if(responseExpected[FUNCTION_BEEP] == ResponseExpectedFlag.ALWAYS_TRUE || responseExpected[FUNCTION_BEEP] == ResponseExpectedFlag.TRUE) 
			{
				byte[] response;
				SendRequestExpectResponse(data_, FUNCTION_BEEP, out response);
			}
			else
			{
				SendRequestNoResponse(data_);
			}
		}

		/// <summary>
		///  Sets morse code that will be played by the piezo buzzer. The morse code
		///  is given as a string consisting of "." (dot), "-" (minus) and " " (space)
		///  for *dits*, *dahs* and *pauses*. Every other character is ignored.
		///  
		///  For example: If you set the string "...---...", the piezo buzzer will beep
		///  nine times with the durations "short short short long long long short 
		///  short short".
		///  
		///  The maximum string size is 60.
		/// </summary>
		public void MorseCode(string morse)
		{
			byte[] data_ = MakePacketHeader(68, FUNCTION_MORSE_CODE);
			LEConverter.To((string)morse, 8, 60, data_);

			if(responseExpected[FUNCTION_MORSE_CODE] == ResponseExpectedFlag.ALWAYS_TRUE || responseExpected[FUNCTION_MORSE_CODE] == ResponseExpectedFlag.TRUE) 
			{
				byte[] response;
				SendRequestExpectResponse(data_, FUNCTION_MORSE_CODE, out response);
			}
			else
			{
				SendRequestNoResponse(data_);
			}
		}

		/// <summary>
		///  Returns the UID, the UID where the Bricklet is connected to, 
		///  the position, the hardware and firmware version as well as the
		///  device identifier.
		///  
		///  The position can be 'a', 'b', 'c' or 'd'.
		///  
		///  The device identifiers are:
		///  
		///  <code>
		///   "Device Identifier", "Device"
		///  
		///   "11", "Brick DC"
		///   "12", "Brick Debug"
		///   "13", "Brick Master 2.0"
		///   "14", "Brick Servo"
		///   "15", "Brick Stepper"
		///   "16", "Brick IMU"
		///   "", ""
		///   "21", "Bricklet Ambient Light"
		///   "22", "Bricklet Breakout"
		///   "23", "Bricklet Current12"
		///   "24", "Bricklet Current25"
		///   "25", "Bricklet Distance IR"
		///   "26", "Bricklet Dual Relay"
		///   "27", "Bricklet Humidity"
		///   "28", "Bricklet IO-16"
		///   "29", "Bricklet IO-4"
		///   "210", "Bricklet Joystick"
		///   "211", "Bricklet LCD 16x2"
		///   "212", "Bricklet LCD 20x4"
		///   "213", "Bricklet Linear Poti"
		///   "214", "Bricklet Piezo Buzzer"
		///   "215", "Bricklet Rotary Poti"
		///   "216", "Bricklet Temperature"
		///   "217", "Bricklet Temperature IR"
		///   "218", "Bricklet Voltage"
		///   "219", "Bricklet Analog In"
		///   "220", "Bricklet Analog Out"
		///   "221", "Bricklet Barometer"
		///   "222", "Bricklet GPS"
		///   "223", "Bricklet Industrial Digital In 4"
		///   "224", "Bricklet Industrial Digital Out 4"
		///   "225", "Bricklet Industrial Quad Relay"
		///   "226", "Bricklet PTC"
		///   "227", "Bricklet Voltage/Current"
		///  </code>
		///  
		///  .. versionadded:: 2.0.0~(Plugin)
		/// </summary>
		public void GetIdentity(out string uid, out string connectedUid, out char position, out byte[] hardwareVersion, out byte[] firmwareVersion, out int deviceIdentifier)
		{
			byte[] data_ = MakePacketHeader(8, FUNCTION_GET_IDENTITY);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_IDENTITY, out response);

			uid = LEConverter.StringFrom(8, response, 8);
			connectedUid = LEConverter.StringFrom(16, response, 8);
			position = LEConverter.CharFrom(24, response);
			hardwareVersion = LEConverter.ByteArrayFrom(25, response, 3);
			firmwareVersion = LEConverter.ByteArrayFrom(28, response, 3);
			deviceIdentifier = LEConverter.UShortFrom(31, response);
		}

		/// <summary>
		/// </summary>
		protected void OnBeepFinished(byte[] data_)
		{
			var handler = BeepFinished;
			if(handler != null)
			{
				handler(this);
			}
		}

		/// <summary>
		/// </summary>
		protected void OnMorseCodeFinished(byte[] data_)
		{
			var handler = MorseCodeFinished;
			if(handler != null)
			{
				handler(this);
			}
		}
	}
}